// -------------------------------------------------------------
// ONf
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float4x4 mWVP;		// [JˉeԂւ̍Wϊ
float4   vCol;		// bV̐F
float4	 vLightPos;	// Cg̈ʒu
float4	 vCamPos;	// J̈ʒu
float	 A;
float	 B;


// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture tSinTan;
sampler SinTanSamp = sampler_state
{
    Texture = <tSinTan>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};


// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
    float3 Normal		: TEXCOORD0;
    float3 Light		: TEXCOORD1;
    float3 Eye			: TEXCOORD2;
};

// -------------------------------------------------------------
// _VF[_
// -------------------------------------------------------------
VS_OUTPUT VS(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL	         // f̖@
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	float4	uv;
	
	// Wϊ
    Out.Pos = mul(Pos, mWVP);
    
	// F
	Out.Color = vCol;
	// vZp̃xNg
	Out.Normal = Normal;
	Out.Light  = vLightPos.xyz - Pos.xyz;
	Out.Eye    = vCamPos.xyz - Pos.xyz;
	
    return Out;
}
// -------------------------------------------------------------
// sNZVF[_
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{
	float4 Out = 0;
	
	float3 l = normalize(In.Light);
	float3 n = normalize(In.Normal);
	float3 e = normalize(In.Eye);
	
	float2 tcoord = {dot(l,n), max(0,dot(e,n))};
	float sintan = tex2D( SinTanSamp, 0.5f * tcoord + 0.5f ).x;
	
	float3 al = normalize(l-dot(l,n)*n);
	float3 ae = normalize(e-dot(e,n)*n);
	float C = max(0, dot(al,ae));

	Out = dot(l,n) * (A + B * C * sintan);
	
//	Out = dot(l, n);	// Lambertian

	return Out;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}
